/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package libsidplay.mem;

public interface IChar {

	public static final byte CHAR[] = {
		(byte) 0x3C, (byte) 0x66, (byte) 0x6E, (byte) 0x6E, (byte) 0x60, (byte) 0x62, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x18, (byte) 0x3C, (byte) 0x66, (byte) 0x7E, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x6C, (byte) 0x78, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x60, (byte) 0x78, (byte) 0x60, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x60, (byte) 0x78, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x6E, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x7E, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x1E, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x6C, (byte) 0x38, (byte) 0x00, 
		(byte) 0x66, (byte) 0x6C, (byte) 0x78, (byte) 0x70, (byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x63, (byte) 0x77, (byte) 0x7F, (byte) 0x6B, (byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x00, 
		(byte) 0x66, (byte) 0x76, (byte) 0x7E, (byte) 0x7E, (byte) 0x6E, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x0E, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x3C, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x00, 
		(byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x6B, (byte) 0x7F, (byte) 0x77, (byte) 0x63, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x0C, (byte) 0x12, (byte) 0x30, (byte) 0x7C, (byte) 0x30, (byte) 0x62, (byte) 0xFC, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x3C, (byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x7F, (byte) 0x7F, (byte) 0x30, (byte) 0x10, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0xFF, (byte) 0x66, (byte) 0xFF, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x18, (byte) 0x3E, (byte) 0x60, (byte) 0x3C, (byte) 0x06, (byte) 0x7C, (byte) 0x18, (byte) 0x00, 
		(byte) 0x62, (byte) 0x66, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x66, (byte) 0x46, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x3C, (byte) 0x38, (byte) 0x67, (byte) 0x66, (byte) 0x3F, (byte) 0x00, 
		(byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x18, (byte) 0x0C, (byte) 0x00, 
		(byte) 0x30, (byte) 0x18, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x00, 
		(byte) 0x00, (byte) 0x66, (byte) 0x3C, (byte) 0xFF, (byte) 0x3C, (byte) 0x66, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x30, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x03, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x6E, (byte) 0x76, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x38, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x0C, (byte) 0x30, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x1C, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x06, (byte) 0x0E, (byte) 0x1E, (byte) 0x66, (byte) 0x7F, (byte) 0x06, (byte) 0x06, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x7C, (byte) 0x06, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x66, (byte) 0x0C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x30, 
		(byte) 0x0E, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x30, (byte) 0x18, (byte) 0x0E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x70, (byte) 0x18, (byte) 0x0C, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x70, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x00, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x08, (byte) 0x1C, (byte) 0x3E, (byte) 0x7F, (byte) 0x7F, (byte) 0x1C, (byte) 0x3E, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, 
		(byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, 
		(byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xE0, (byte) 0xF0, (byte) 0x38, (byte) 0x18, (byte) 0x18, 
		(byte) 0x18, (byte) 0x18, (byte) 0x1C, (byte) 0x0F, (byte) 0x07, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x38, (byte) 0xF0, (byte) 0xE0, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xC0, (byte) 0xE0, (byte) 0x70, (byte) 0x38, (byte) 0x1C, (byte) 0x0E, (byte) 0x07, (byte) 0x03, 
		(byte) 0x03, (byte) 0x07, (byte) 0x0E, (byte) 0x1C, (byte) 0x38, (byte) 0x70, (byte) 0xE0, (byte) 0xC0, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, 
		(byte) 0x00, (byte) 0x3C, (byte) 0x7E, (byte) 0x7E, (byte) 0x7E, (byte) 0x7E, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, 
		(byte) 0x36, (byte) 0x7F, (byte) 0x7F, (byte) 0x7F, (byte) 0x3E, (byte) 0x1C, (byte) 0x08, (byte) 0x00, 
		(byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x07, (byte) 0x0F, (byte) 0x1C, (byte) 0x18, (byte) 0x18, 
		(byte) 0xC3, (byte) 0xE7, (byte) 0x7E, (byte) 0x3C, (byte) 0x3C, (byte) 0x7E, (byte) 0xE7, (byte) 0xC3, 
		(byte) 0x00, (byte) 0x3C, (byte) 0x7E, (byte) 0x66, (byte) 0x66, (byte) 0x7E, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x66, (byte) 0x66, (byte) 0x18, (byte) 0x18, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, 
		(byte) 0x08, (byte) 0x1C, (byte) 0x3E, (byte) 0x7F, (byte) 0x3E, (byte) 0x1C, (byte) 0x08, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xFF, (byte) 0xFF, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0x30, (byte) 0x30, (byte) 0xC0, (byte) 0xC0, (byte) 0x30, (byte) 0x30, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x03, (byte) 0x3E, (byte) 0x76, (byte) 0x36, (byte) 0x36, (byte) 0x00, 
		(byte) 0xFF, (byte) 0x7F, (byte) 0x3F, (byte) 0x1F, (byte) 0x0F, (byte) 0x07, (byte) 0x03, (byte) 0x01, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, 
		(byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, 
		(byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, 
		(byte) 0xFF, (byte) 0xFE, (byte) 0xFC, (byte) 0xF8, (byte) 0xF0, (byte) 0xE0, (byte) 0xC0, (byte) 0x80, 
		(byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x1F, (byte) 0x1F, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x1F, (byte) 0x1F, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xF8, (byte) 0xF8, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x1F, (byte) 0x1F, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xF8, (byte) 0xF8, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, 
		(byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, 
		(byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xF8, (byte) 0xF8, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x91, (byte) 0x91, (byte) 0x9F, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xC3, (byte) 0x99, (byte) 0x81, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x93, (byte) 0x87, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x9F, (byte) 0x87, (byte) 0x9F, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x9F, (byte) 0x87, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x91, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x81, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE1, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0x93, (byte) 0xC7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x93, (byte) 0x87, (byte) 0x8F, (byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0x9C, (byte) 0x88, (byte) 0x80, (byte) 0x94, (byte) 0x9C, (byte) 0x9C, (byte) 0x9C, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x89, (byte) 0x81, (byte) 0x81, (byte) 0x91, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xF1, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0xC3, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x9C, (byte) 0x9C, (byte) 0x9C, (byte) 0x94, (byte) 0x80, (byte) 0x88, (byte) 0x9C, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x81, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xF3, (byte) 0xED, (byte) 0xCF, (byte) 0x83, (byte) 0xCF, (byte) 0x9D, (byte) 0x03, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0xC3, (byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xEF, (byte) 0xCF, (byte) 0x80, (byte) 0x80, (byte) 0xCF, (byte) 0xEF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x00, (byte) 0x99, (byte) 0x00, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xC1, (byte) 0x9F, (byte) 0xC3, (byte) 0xF9, (byte) 0x83, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x9D, (byte) 0x99, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x99, (byte) 0xB9, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xC3, (byte) 0xC7, (byte) 0x98, (byte) 0x99, (byte) 0xC0, (byte) 0xFF, 
		(byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xE7, (byte) 0xF3, (byte) 0xFF, 
		(byte) 0xCF, (byte) 0xE7, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x99, (byte) 0xC3, (byte) 0x00, (byte) 0xC3, (byte) 0x99, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xCF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFC, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x91, (byte) 0x89, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xC7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xF3, (byte) 0xCF, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xE3, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xF9, (byte) 0xF1, (byte) 0xE1, (byte) 0x99, (byte) 0x80, (byte) 0xF9, (byte) 0xF9, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x83, (byte) 0xF9, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x99, (byte) 0xF3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xCF, 
		(byte) 0xF1, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0xCF, (byte) 0xE7, (byte) 0xF1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x8F, (byte) 0xE7, (byte) 0xF3, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0x8F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xF7, (byte) 0xE3, (byte) 0xC1, (byte) 0x80, (byte) 0x80, (byte) 0xE3, (byte) 0xC1, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, 
		(byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x1F, (byte) 0x0F, (byte) 0xC7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE3, (byte) 0xF0, (byte) 0xF8, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xC7, (byte) 0x0F, (byte) 0x1F, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x00, (byte) 0x00, 
		(byte) 0x3F, (byte) 0x1F, (byte) 0x8F, (byte) 0xC7, (byte) 0xE3, (byte) 0xF1, (byte) 0xF8, (byte) 0xFC, 
		(byte) 0xFC, (byte) 0xF8, (byte) 0xF1, (byte) 0xE3, (byte) 0xC7, (byte) 0x8F, (byte) 0x1F, (byte) 0x3F, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, 
		(byte) 0x00, (byte) 0x00, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, 
		(byte) 0xFF, (byte) 0xC3, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, 
		(byte) 0xC9, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0xC1, (byte) 0xE3, (byte) 0xF7, (byte) 0xFF, 
		(byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xF8, (byte) 0xF0, (byte) 0xE3, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0x3C, (byte) 0x18, (byte) 0x81, (byte) 0xC3, (byte) 0xC3, (byte) 0x81, (byte) 0x18, (byte) 0x3C, 
		(byte) 0xFF, (byte) 0xC3, (byte) 0x81, (byte) 0x99, (byte) 0x99, (byte) 0x81, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0x99, (byte) 0x99, (byte) 0xE7, (byte) 0xE7, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, 
		(byte) 0xF7, (byte) 0xE3, (byte) 0xC1, (byte) 0x80, (byte) 0xC1, (byte) 0xE3, (byte) 0xF7, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x00, (byte) 0x00, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0xCF, (byte) 0xCF, (byte) 0x3F, (byte) 0x3F, (byte) 0xCF, (byte) 0xCF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFC, (byte) 0xC1, (byte) 0x89, (byte) 0xC9, (byte) 0xC9, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x80, (byte) 0xC0, (byte) 0xE0, (byte) 0xF0, (byte) 0xF8, (byte) 0xFC, (byte) 0xFE, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, 
		(byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, 
		(byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, 
		(byte) 0x00, (byte) 0x01, (byte) 0x03, (byte) 0x07, (byte) 0x0F, (byte) 0x1F, (byte) 0x3F, (byte) 0x7F, 
		(byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE0, (byte) 0xE0, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE0, (byte) 0xE0, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x07, (byte) 0x07, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE0, (byte) 0xE0, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x07, (byte) 0x07, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, 
		(byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, 
		(byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, 
		(byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x07, (byte) 0x07, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x6E, (byte) 0x6E, (byte) 0x60, (byte) 0x62, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3C, (byte) 0x06, (byte) 0x3E, (byte) 0x66, (byte) 0x3E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x60, (byte) 0x60, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3C, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x06, (byte) 0x06, (byte) 0x3E, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3C, (byte) 0x66, (byte) 0x7E, (byte) 0x60, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x0E, (byte) 0x18, (byte) 0x3E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3E, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x06, (byte) 0x7C, 
		(byte) 0x00, (byte) 0x60, (byte) 0x60, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x38, (byte) 0x18, (byte) 0x18, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x06, (byte) 0x00, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x06, (byte) 0x3C, 
		(byte) 0x00, (byte) 0x60, (byte) 0x60, (byte) 0x6C, (byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x00, (byte) 0x38, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x66, (byte) 0x7F, (byte) 0x7F, (byte) 0x6B, (byte) 0x63, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x60, (byte) 0x60, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3E, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x06, (byte) 0x06, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7C, (byte) 0x66, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x3E, (byte) 0x60, (byte) 0x3C, (byte) 0x06, (byte) 0x7C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x0E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x63, (byte) 0x6B, (byte) 0x7F, (byte) 0x3E, (byte) 0x36, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x3C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x0C, (byte) 0x78, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7E, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x0C, (byte) 0x12, (byte) 0x30, (byte) 0x7C, (byte) 0x30, (byte) 0x62, (byte) 0xFC, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x3C, (byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x7F, (byte) 0x7F, (byte) 0x30, (byte) 0x10, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0xFF, (byte) 0x66, (byte) 0xFF, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x18, (byte) 0x3E, (byte) 0x60, (byte) 0x3C, (byte) 0x06, (byte) 0x7C, (byte) 0x18, (byte) 0x00, 
		(byte) 0x62, (byte) 0x66, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x66, (byte) 0x46, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x3C, (byte) 0x38, (byte) 0x67, (byte) 0x66, (byte) 0x3F, (byte) 0x00, 
		(byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x18, (byte) 0x0C, (byte) 0x00, 
		(byte) 0x30, (byte) 0x18, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x00, 
		(byte) 0x00, (byte) 0x66, (byte) 0x3C, (byte) 0xFF, (byte) 0x3C, (byte) 0x66, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x30, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x03, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x6E, (byte) 0x76, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x38, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x0C, (byte) 0x30, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x1C, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x06, (byte) 0x0E, (byte) 0x1E, (byte) 0x66, (byte) 0x7F, (byte) 0x06, (byte) 0x06, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x7C, (byte) 0x06, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x66, (byte) 0x0C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x3E, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x30, 
		(byte) 0x0E, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x30, (byte) 0x18, (byte) 0x0E, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x7E, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x70, (byte) 0x18, (byte) 0x0C, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x70, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x00, (byte) 0x18, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x3C, (byte) 0x66, (byte) 0x7E, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x6C, (byte) 0x78, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x60, (byte) 0x78, (byte) 0x60, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x60, (byte) 0x60, (byte) 0x78, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x6E, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x7E, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x1E, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x0C, (byte) 0x6C, (byte) 0x38, (byte) 0x00, 
		(byte) 0x66, (byte) 0x6C, (byte) 0x78, (byte) 0x70, (byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x63, (byte) 0x77, (byte) 0x7F, (byte) 0x6B, (byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x00, 
		(byte) 0x66, (byte) 0x76, (byte) 0x7E, (byte) 0x7E, (byte) 0x6E, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x60, (byte) 0x60, (byte) 0x60, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x0E, (byte) 0x00, 
		(byte) 0x7C, (byte) 0x66, (byte) 0x66, (byte) 0x7C, (byte) 0x78, (byte) 0x6C, (byte) 0x66, (byte) 0x00, 
		(byte) 0x3C, (byte) 0x66, (byte) 0x60, (byte) 0x3C, (byte) 0x06, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x00, 
		(byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x6B, (byte) 0x7F, (byte) 0x77, (byte) 0x63, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x3C, (byte) 0x66, (byte) 0x66, (byte) 0x00, 
		(byte) 0x66, (byte) 0x66, (byte) 0x66, (byte) 0x3C, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, 
		(byte) 0x7E, (byte) 0x06, (byte) 0x0C, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x7E, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xFF, (byte) 0xFF, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0x30, (byte) 0x30, (byte) 0xC0, (byte) 0xC0, (byte) 0x30, (byte) 0x30, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, 
		(byte) 0x33, (byte) 0x99, (byte) 0xCC, (byte) 0x66, (byte) 0x33, (byte) 0x99, (byte) 0xCC, (byte) 0x66, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, 
		(byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, 
		(byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, 
		(byte) 0xCC, (byte) 0x99, (byte) 0x33, (byte) 0x66, (byte) 0xCC, (byte) 0x99, (byte) 0x33, (byte) 0x66, 
		(byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, (byte) 0x03, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x1F, (byte) 0x1F, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x1F, (byte) 0x1F, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xF8, (byte) 0xF8, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x1F, (byte) 0x1F, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xF8, (byte) 0xF8, (byte) 0x18, (byte) 0x18, (byte) 0x18, 
		(byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, (byte) 0xC0, 
		(byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, (byte) 0xE0, 
		(byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, (byte) 0x07, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x01, (byte) 0x03, (byte) 0x06, (byte) 0x6C, (byte) 0x78, (byte) 0x70, (byte) 0x60, (byte) 0x00, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0xF8, (byte) 0xF8, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x91, (byte) 0x91, (byte) 0x9F, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC3, (byte) 0xF9, (byte) 0xC1, (byte) 0x99, (byte) 0xC1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x9F, (byte) 0x9F, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC3, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xF9, (byte) 0xF9, (byte) 0xC1, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC3, (byte) 0x99, (byte) 0x81, (byte) 0x9F, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xF1, (byte) 0xE7, (byte) 0xC1, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC1, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xF9, (byte) 0x83, 
		(byte) 0xFF, (byte) 0x9F, (byte) 0x9F, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xC7, (byte) 0xE7, (byte) 0xE7, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xF9, (byte) 0xFF, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xF9, (byte) 0xC3, 
		(byte) 0xFF, (byte) 0x9F, (byte) 0x9F, (byte) 0x93, (byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xC7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x99, (byte) 0x80, (byte) 0x80, (byte) 0x94, (byte) 0x9C, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x9F, (byte) 0x9F, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC1, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xF9, (byte) 0xF9, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x83, (byte) 0x99, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xC1, (byte) 0x9F, (byte) 0xC3, (byte) 0xF9, (byte) 0x83, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xF1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x9C, (byte) 0x94, (byte) 0x80, (byte) 0xC1, (byte) 0xC9, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xC3, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xF3, (byte) 0x87, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x81, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xF3, (byte) 0xED, (byte) 0xCF, (byte) 0x83, (byte) 0xCF, (byte) 0x9D, (byte) 0x03, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0xC3, (byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xEF, (byte) 0xCF, (byte) 0x80, (byte) 0x80, (byte) 0xCF, (byte) 0xEF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x00, (byte) 0x99, (byte) 0x00, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xC1, (byte) 0x9F, (byte) 0xC3, (byte) 0xF9, (byte) 0x83, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x9D, (byte) 0x99, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x99, (byte) 0xB9, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xC3, (byte) 0xC7, (byte) 0x98, (byte) 0x99, (byte) 0xC0, (byte) 0xFF, 
		(byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0xCF, (byte) 0xCF, (byte) 0xE7, (byte) 0xF3, (byte) 0xFF, 
		(byte) 0xCF, (byte) 0xE7, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0x99, (byte) 0xC3, (byte) 0x00, (byte) 0xC3, (byte) 0x99, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xCF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFC, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x91, (byte) 0x89, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xC7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xF3, (byte) 0xCF, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xE3, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xF9, (byte) 0xF1, (byte) 0xE1, (byte) 0x99, (byte) 0x80, (byte) 0xF9, (byte) 0xF9, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x83, (byte) 0xF9, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x99, (byte) 0xF3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xC1, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, (byte) 0xFF, (byte) 0xE7, (byte) 0xE7, (byte) 0xCF, 
		(byte) 0xF1, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0xCF, (byte) 0xE7, (byte) 0xF1, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0x81, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x8F, (byte) 0xE7, (byte) 0xF3, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0x8F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xFF, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xC3, (byte) 0x99, (byte) 0x81, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x93, (byte) 0x87, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x9F, (byte) 0x87, (byte) 0x9F, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0x81, (byte) 0x9F, (byte) 0x9F, (byte) 0x87, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0x91, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x81, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0xE1, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0xF3, (byte) 0x93, (byte) 0xC7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x93, (byte) 0x87, (byte) 0x8F, (byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0x9C, (byte) 0x88, (byte) 0x80, (byte) 0x94, (byte) 0x9C, (byte) 0x9C, (byte) 0x9C, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x89, (byte) 0x81, (byte) 0x81, (byte) 0x91, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x9F, (byte) 0x9F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xF1, (byte) 0xFF, 
		(byte) 0x83, (byte) 0x99, (byte) 0x99, (byte) 0x83, (byte) 0x87, (byte) 0x93, (byte) 0x99, (byte) 0xFF, 
		(byte) 0xC3, (byte) 0x99, (byte) 0x9F, (byte) 0xC3, (byte) 0xF9, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x81, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x9C, (byte) 0x9C, (byte) 0x9C, (byte) 0x94, (byte) 0x80, (byte) 0x88, (byte) 0x9C, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xC3, (byte) 0x99, (byte) 0x99, (byte) 0xFF, 
		(byte) 0x99, (byte) 0x99, (byte) 0x99, (byte) 0xC3, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xFF, 
		(byte) 0x81, (byte) 0xF9, (byte) 0xF3, (byte) 0xE7, (byte) 0xCF, (byte) 0x9F, (byte) 0x81, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x00, (byte) 0x00, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0xCF, (byte) 0xCF, (byte) 0x3F, (byte) 0x3F, (byte) 0xCF, (byte) 0xCF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, 
		(byte) 0xCC, (byte) 0x66, (byte) 0x33, (byte) 0x99, (byte) 0xCC, (byte) 0x66, (byte) 0x33, (byte) 0x99, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, 
		(byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, 
		(byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x33, (byte) 0x33, (byte) 0xCC, (byte) 0xCC, 
		(byte) 0x33, (byte) 0x66, (byte) 0xCC, (byte) 0x99, (byte) 0x33, (byte) 0x66, (byte) 0xCC, (byte) 0x99, 
		(byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, (byte) 0xFC, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE0, (byte) 0xE0, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0xE0, (byte) 0xE0, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x07, (byte) 0x07, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xE0, (byte) 0xE0, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x07, (byte) 0x07, (byte) 0xE7, (byte) 0xE7, (byte) 0xE7, 
		(byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, (byte) 0x3F, 
		(byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, (byte) 0x1F, 
		(byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, (byte) 0xF8, 
		(byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x00, (byte) 0x00, (byte) 0x00, 
		(byte) 0xFE, (byte) 0xFC, (byte) 0xF9, (byte) 0x93, (byte) 0x87, (byte) 0x8F, (byte) 0x9F, (byte) 0xFF, 
		(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, 
		(byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0xE7, (byte) 0xE7, (byte) 0xE7, (byte) 0x07, (byte) 0x07, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF, 
		(byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0x0F, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, (byte) 0xF0, 
		};
}
