/**
 * This file is part of reSID, a MOS6581 SID emulator engine.
 * Copyright (C) 1999  Dag Lem <resid@nimrod.no>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * @author Ken Hndel
 *
 */
package resid_builder.resid;

public interface ISIDDefs {
	public enum ChipModel {
		MOS6581, MOS8580
	}

	public enum SamplingMethod {
		DECIMATE("Decimate"), RESAMPLE("Resample");

		final String description;
		
		SamplingMethod(String description) {
			this.description = description;
		}

		@Override
		public String toString() {
			return description;
		}
	}
}
